# cygtel.tcl
#
# Defines the Oc_Config name 'cygtel' to indicate the Windows 95/NT operating
# system running on an Intel architecture, using Cygwin Tcl/Tk.

Oc_Config New _ [string tolower [file rootname [file tail [info script]]]] {
    global tcl_platform env
    if {![regexp -nocase -- windows $tcl_platform(platform)]} {
        return 0
    }
    if {![string match intel $tcl_platform(machine)]} {
	return 0
    }
    if {[info exists env(OSTYPE)] && 
	    [string match cygwin* [string tolower $env(OSTYPE)]]} {
	return 1
    }
    if {[info exists env(TERM)] && 
	    [string match cygwin [string tolower $env(TERM)]]} {
	return 1
    }
    return 0
}
